# -*- coding: utf-8 -*-
"""
    Module: pySRIMfit
    File:   t_srimWB.py
    Descr.: TEST srimWS(), srimWB()
    Update: 230408 build start Ay
    Last:   230416 ver.1.0

@author: Ayoshida(RIKEN,Nishina center)
"""

""" import: standard lib.       
----.---.---.---.---.---.---.---.---.---.---.---.---"""

""" import: my custom lib.       
----.---.---.---.---.---.---.---.---.---.---.---.---"""
#import  aypylib             as ay 

""" import: from this package   
----.---.---.---.---.---.---.---.---.---.---.---.---"""
from    pySRIMfit   import  (srimWB, srimWBcnv_xl2pick,
                             srimWSplot_LET, srimWSplot_RngSt,
                             srimWSplot_LETcmp, srimWSplot_RngStcmp)

""" ========================================================
            Main
    ========================================================"""
if __name__ == '__main__':
    import  time
    from  pprint  import  pprint

    """ Test-CTRL Sw ---.---.---.---.---.---.---.---.---"""
    SwTest01 = False    # make srWB() & save it as .pickle
    SwTest02 = True     # load srWB() from .pickle ; need for later tests
    SwTest11 = False    # test srimWS()
    SwTest21 = True     # test srimWB()

    """ run params """
    #__ Input: MySRIMwb example 
    fnInXl1 = './_MySRIMwb_eg/_samples/MySRIMwb_test1.xlsx' # incl. 2-sheets
    fnInXl2 = './_MySRIMwb_eg/_samples/MySRIMwb_test2.xlsx' # incl. 6-sheets
    drInPk  = './'

    """ Test01 : make a simple srWB() & save as .pickle
    input  = fnInXl MySRIMwb.xlsx   min.sample
    output = fnInPk MySRIMwb.pickle converted pickle file
    ------------
        Elapse      3.22s / 2+6-sheets
        File Size   46kB/2sh  182kB/8sh ie) (182-46)/6 = 22.7kB/sh
    ----.---.---.---.---.---.---.---.---.---.---.---.---"""
    if(SwTest01):
        #fnL = [fnInXl1]
        fnL = [fnInXl1,fnInXl2]
        tms = time.time()
        srWB= srimWBcnv_xl2pick(xlfnL=fnL,dirOut='./')
        tme = time.time()
        print("Test01: srimWScnv_xl2pick(): elapsed[s]={:.2f}".format(tme-tms))

    """ Test02 : load srWB() from fnInPk.pickle
    input  = fnInXl MySRIMwb.pickle min.sample
    ------------
        Elapse 0.00s / 2+6-sheets
    ----.---.---.---.---.---.---.---.---.---.---.---.---"""
    if(SwTest02):       
        tms = time.time()
        srWB= srimWB()
        srWB.loadWS(path=drInPk)
        tme = time.time()
        print("Test02: srimWB.loadWS(): elapsed[s]={:.2f}".format(tme-tms))
        print(srWB.WSnameL)

    """ Test11 : test srWS()
    ----.---.---.---.---.---.---.---.---.---.---.---.---"""
    if(SwTest11):
        if(False):
            print('__ srWS.info() __') 
            WSnm = 'srim40Ar_Si'
            #WSnm = 'srim40Ar_Air'
            #WSnm = 'srim84Kr_Si'
            #WSnm = 'srim84Kr_Air'
            #WSnm = 'srim84Kr_Water'
            srWS = srWB.getWS(WSnm)
            #srWS.info(modL=[0,4,5,6],show=True)   # mode = 0,1,2,..,5
            srWS.info(modL=[-1],intrvE=5,show=True)         # mode = -1 == all
        if(True):
            print('__ ThkStdGas(), mm2umGas(), um2mmGas() __') 
            #WSnm = 'srim40Ar_Air'
            WSnm = 'srim84Kr_Air'
            srWS = srWB.getWS(WSnm)
            #Tmm,Pa,degC = 100., 101325., 20.
            Tmm,Pa,degC = 100., 101000., 25.
            kG  = srWS.ThkStdGas(Pa,degC)
            Tum = srWS.mm2umGas(Tmm,Pa,degC)
            print(' ThkStdGas(Pa[{:.2f}],degC[{:.2f}]) = {:.3f}'.format(
                Pa,degC,kG)  )
            print(' mm2umGas(Tmm[{:.2f}],Pa[{:.2f}],degC[{:.2f}]) = {:.3f}'.format(
                Tmm,Pa,degC,Tum)  )
            Tmm2= srWS.um2mmGas(Tum,Pa,degC)
            print(' um2mmGas(Tum[{:.2f}],Pa[{:.2f}],degC[{:.2f}]) = {:.3f}'.format(
                Tum,Pa,degC,Tmm2)  )
            print(' -> diff=[{:.4e}]'.format(Tmm - Tmm2))
        if(False):
            print('__ srimWSplot_LET(),_RngSt() __') 
            WSnm = 'srim84Kr_Si'
            srWS = srWB.getWS(WSnm)
            srimWSplot_LET(srWS)
            #srimWSplot_LET(srWS,LETn=False,rngX=(1e-3,1e1))
            srimWSplot_RngSt(srWS)
        if(False):
            print('__ srimWS.plotLET(),.plotRngSt() __') 
            WSnm = 'srim84Kr_Si'
            srWS = srWB.getWS(WSnm)
            srWS.plotLET()
            srWS.plotRngSt()
        if(False):
            print('__ srimWSplot_LETcmp(),_RngStcmp() __') 
            wsnmL = ['srim84Kr_Si','srim84Kr_Water','srim84Kr_Air']
            wsL = srWB.getWSL(wsnmL)
            srimWSplot_LETcmp(wsL)
            srimWSplot_RngStcmp(wsL)
        if(False):
            print('__ diff srWS.E2LET() -> LET2E() __')
            WSnm = 'srim84Kr_Si'
            srWS = srWB.getWS(WSnm)
            E, uid, hsd = 4.0, 9, True
            def _comp(typ,fnc,ifnc):
                e2l= fnc(E,uid)
                l2e= ifnc(e2l,Uid=uid,Hside=hsd)
                print(' E2LET{}(E[{:.2f}], Uid=[{}]) = {:.3e}'.format(
                    typ, E, uid, e2l ))
                print(' LET{}2E(LET[{:.3e}], Uid=[{}], Hside=[{}]) = {:.3f}'.format(
                    typ, e2l, uid, hsd, l2e))
                print(' -> diff=[{:.4e}]'.format(l2e - E))
            _comp('e', srWS.E2LETe, srWS.LETe2E)
            _comp('n', srWS.E2LETn, srWS.LETn2E)
            _comp('t', srWS.E2LETt, srWS.LETt2E)
        if(False):
            print('__ diff srWS.Rng,StLng,StLtr() -> inv.funcs() __')
            WSnm = 'srim84Kr_Si'
            srWS = srWB.getWS(WSnm)
            E = 2.0
            def _comp(typ,fnc,ifnc):
                e2v= fnc(E)
                v2e= ifnc(e2v)
                print(' {}( E[{:.2f}] ) = {:.3e}'.format(
                    typ, E, e2v ))
                print(' {}2E( {}[{:.3e}] ) = {:.3f}'.format(
                    typ, typ, e2v, v2e))
                print(' -> diff=[{:.4e}]'.format(v2e - E))
            _comp('Rng',   srWS.E2Rng,   srWS.Rng2E)
            _comp('StLng', srWS.E2StLng, srWS.StLng2E)
            _comp('StLtr', srWS.E2StLtr, srWS.StLtr2E)
        if(False):
            print('__ srWS.Enew() -> Eold() __') 
            WSnm = 'srim84Kr_Si'
            srWS = srWB.getWS(WSnm)
            E0, Tum = 15., 20.
            E1 = srWS.Enew(E0,Tum)
            Eo = srWS.Eold(E1,Tum)
            print(' Enew( E0[{:.2f}], Tum[{:.1f}] ) = {:.3f}'.format(
                E0,Tum, E1)  )
            print(' Eold( E1[{:.2f}], Tum[{:.1f}] ) = {:.3f}'.format(
                E1,Tum, Eo)  )
            print(' -> diff=[{:.4e}]'.format(Eo - E0))
        if(True):
            print('__ srWS.EnewGas() -> EoldGas() __') 
            WSnm = 'srim84Kr_Air'
            srWS = srWB.getWS(WSnm)
            E0, Tmm, Pa, degC = 10., 100., 101000, 25.
            E1 = srWS.EnewGas(E0,Tmm,Pa,degC)
            Eo = srWS.EoldGas(E1,Tmm,Pa,degC)
            print((' EnewGas( E0[{:.2f}], Tmm[{:.1f}],'
                   ' Pa[{:.1f}], degC[{:.1f}] ) = {:.3f}').format(
                E0,Tmm, Pa, degC, E1)  )
            print((' EoldGas( E0[{:.2f}], Tmm[{:.1f}],'
                   ' Pa[{:.1f}], degC[{:.1f}] ) = {:.3f}').format(
                E1,Tmm, Pa, degC, Eo)  )
            print(' -> diff=[{:.4e}]'.format(Eo - E0))

    """ Test21 : test srWB()
    ----.---.---.---.---.---.---.---.---.---.---.---.---"""
    if(SwTest21):
        if(False):
            print('__ .getWSnmL() __') 
            wsnmL = srWB.getWSnmL(Beam='Kr',Trg='Si',swSort=1)
            print(wsnmL)
            wsnmLDB = srWB.getWSnmLDB(Beam='Kr',swSort=1)
            pprint(wsnmLDB,width=100,sort_dicts=False)
        if(False):
            print('__ .WBinfo() __') 
            srWB.info()
            srWB.WBinfo()
        if(True):
            print('__ .WBdump() __') 
            tms = time.time()
            wsnmL = ['srim84Kr_Si','srim84Kr_Air']
            #wsnmL = srWB.getWSnmLDB(Beam='Kr',swSort=1)
            srWB.WBdump(wsnmL)      # dump selected srWS
            #srWB.WBdump()          # dump all srWS        
            tme = time.time()
            print("Test21: srimWBdump(): elapsed[s]={:.2f}".format(tme-tms))
            """  Elapse 183s, 35MB / 314-sheets """
        if(False):
            print('__ .Rng_eq_Eold() __') 
            E10,wsnm1,wsnm2 = 1.0, 'srim40Ar_Si','srim197Au_Al'
            E20 = srWB.Rng_eq_Eold(wsnm1,wsnm2,E10)
            print(' Rng_eq_Eold( {},{}, E10[{:.2f}] ) = {:.3f}'.format(
                wsnm1,wsnm2,E10,E20)  )
        if(False):
            print('__ .Enew_eq_Th() __') 
            wsnm1,wsnm2 = 'srim40Ar_Si','srim84Kr_Si'
            E10,Th1 =  10., 20.    # OK 
            #E10,Th1 = 20., 100.     # Err
            #E10,Th1 = 20., 1000.    # Err
            Th2 = srWB.Enew_eq_Th(wsnm1,wsnm2,E10,Th1)
            print(' Enew_eq_Th( {},{}, E10[{:.2f}], Th1[{:.2f}] ) = {:.3f}'.format(
                wsnm1,wsnm2,E10,Th1,Th2)  )
            Th3 = srWB.Enewt_eq_Th(wsnm1,wsnm2,E10,Th1)
            print(' Enewt_eq_Th( {},{}, E10[{:.2f}], Th1[{:.2f}] ) = {:.3f}'.format(
                wsnm1,wsnm2,E10,Th1,Th3)  )
        if(False):
            print('__ .Enew_eq_ThGas() __') 
            wsnm1,wsnm2 = 'srim84Kr_Air','srim40Ar_Air'
            Pa0,dgC0 = 101325., 20.
            Pa1,dgC1 = Pa0*0.9, dgC0
            Pa2,dgC2 = Pa0*1.1, dgC0
            print('Pa1,Pa2=',Pa1,Pa2)
            E10,Tmm1 =  1., 10.     # OK 
            Tmm2 = srWB.Enew_eq_ThGas(wsnm1,wsnm2,E10,Tmm1,Pa1,dgC1,Pa2,dgC2)
            print(' Enew_eq_ThGas( {},{}, E10[{:.2f}],Tmm1[{:.2f}] ) = {:.3f}'.format(
                wsnm1,wsnm2,E10,Tmm1,Tmm2)  )
            Tmm3 = srWB.Enewt_eq_ThGas(wsnm1,wsnm2,E10,Tmm1,Pa1,dgC1,Pa2,dgC2)
            print(' Enewt_eq_ThGas( {},{}, E10[{:.2f}],Tmm1[{:.2f}] ) = {:.3f}'.format(
                wsnm1,wsnm2,E10,Tmm1,Tmm3)  )
        if(False):
            print('__ .Enew_eq_Eold() __') 
            wsnm1,wsnm2 = 'srim197Au_Si','srim40Ar_Al'
            E10,Th1 = 10., 20.      # OK 
            E20 = srWB.Enew_eq_Eold(wsnm1,wsnm2,E10,Th1)
            print(' Enew_eq_Eold( {},{}, E10[{:.2f}], Th1[{:.2f}] ) = {:.3f}'.format(
                wsnm1,wsnm2,E10,Th1,E20)  )
            E20t= srWB.Enewt_eq_Eold(wsnm1,wsnm2,E10,Th1)
            print(' Enewt_eq_Eold( {},{}, E10[{:.2f}], Th1[{:.2f}] ) = {:.3f}'.format(
                wsnm1,wsnm2,E10,Th1,E20t)  )
        if(False):
            print('__ .Enew_eq_EoldGas() __') 
            wsnm1,wsnm2 = 'srim84Kr_Air','srim40Ar_Air'
            Pa0,dgC0 = 101325., 20.
            Pa1,dgC1 = Pa0*0.9,dgC0
            Pa2,dgC2 = Pa0*1.1,dgC0
            print('Pa1,Pa2=',Pa1,Pa2)
            E10,Tmm1 = 1., 10.      # OK
            E20 = srWB.Enew_eq_EoldGas(wsnm1,wsnm2,E10,Tmm1,Pa1,dgC1,Pa2,dgC2)
            print(' Enew_eq_EoldGas( {},{}, E10[{:.2f}], Tmm1[{:.2f}] ) = {:.3f}'.format(
                wsnm1,wsnm2,E10,Tmm1,E20)  )
            E20t= srWB.Enewt_eq_EoldGas(wsnm1,wsnm2,E10,Tmm1,Pa1,dgC1,Pa2,dgC2)
            print(' Enewt_eq_EoldGas( {},{}, E10[{:.2f}], Th1[{:.2f}] ) = {:.3f}'.format(
                wsnm1,wsnm2,E10,Tmm1,E20t)  )
        if(False):
            print('__ .dEu_eq_Th() == .Enew_eq_Th() __') 
            wsnm1,wsnm2 = 'srim40Ar_Si','srim84Kr_Si'
            E10,Th1 =  10., 20.    # OK 
            #E10,Th1 = 10., 0.       # OK
            Th2 = srWB.dEu_eq_Th(wsnm1,wsnm2,E10,Th1)
            print(' dEu_eq_Th( {},{}, E10[{:.2f}], Th1[{:.2f}] ) = {:.3f}'.format(
                wsnm1,wsnm2,E10,Th1,Th2)  )
            Th3 = srWB.dEt_eq_Th(wsnm1,wsnm2,E10,Th1)
            print(' dEt_eq_Th( {},{}, E10[{:.2f}], Th1[{:.2f}] ) = {:.3f}'.format(
                wsnm1,wsnm2,E10,Th1,Th3)  )
        if(False):
            print('__ .dEu_eq_ThGas() Enew_eq_ThGas() __') 
            wsnm1,wsnm2 = 'srim132Xe_Air','srim40Ar_Air'
            Pa0,dgC0 = 101325., 20.
            Pa1,dgC1 = Pa0*0.9, dgC0
            Pa2,dgC2 = Pa0*1.1, dgC0
            print('Pa1,Pa2=',Pa1,Pa2)
            E10,Tmm1 =  1., 4.     # OK 
            Tmm2 = srWB.dEu_eq_ThGas(wsnm1,wsnm2,E10,Tmm1,Pa1,dgC1,Pa2,dgC2)
            print(' dEu_eq_ThGas( {},{}, E10[{:.2f}],Tmm1[{:.2f}]) = {:.3f}'.format(
                wsnm1,wsnm2,E10,Tmm1,Tmm2)  )
            Tmm3 = srWB.dEt_eq_ThGas(wsnm1,wsnm2,E10,Tmm1,Pa1,dgC1,Pa2,dgC2)
            print(' dEt_eq_ThGas( {},{}, E10[{:.2f}],Tmm1[{:.2f}]) = {:.3f}'.format(
                wsnm1,wsnm2,E10,Tmm1,Tmm3)  )
        if(False):
            print('__ .dE_eq_Eold() __') 
            wsnm1,wsnm2 = 'srim40Ar_Au','srim84Kr_Si'
            E10,Th1 = 0.5, 5.0      # OK
            #E10,Th1 = 10., 5.0      # Err
            E20h = srWB.dEu_eq_Eold(wsnm1,wsnm2,E10,Th1,Hside=True)
            E20l = srWB.dEu_eq_Eold(wsnm1,wsnm2,E10,Th1,Hside=False)
            print(' dEu_eq_Eold( {},{}, E10[{:.2f}],Th1[{:.2f}],Hside=T ) = {:.3f}'.format(
                wsnm1,wsnm2,E10,Th1,E20h)  )
            print(' dEu_eq_Eold( {},{}, E10[{:.2f}],Th1[{:.2f}],Hside=F ) = {:.3f}'.format(
                wsnm1,wsnm2,E10,Th1,E20l)  )
            #E10,Th1 = 0.5, 5.0      # OK
            #E10,Th1 = 10., 5.0      # Err
            E20h = srWB.dEt_eq_Eold(wsnm1,wsnm2,E10,Th1,Hside=True)
            E20l = srWB.dEt_eq_Eold(wsnm1,wsnm2,E10,Th1,Hside=False)
            print(' dEt_eq_Eold( {},{}, E10[{:.2f}],Th1[{:.2f}],Hside=T ) = {:.3f}'.format(
                wsnm1,wsnm2,E10,Th1,E20h)  )
            print(' dEt_eq_Eold( {},{}, E10[{:.2f}],Th1[{:.2f}],Hside=F ) = {:.3f}'.format(
                wsnm1,wsnm2,E10,Th1,E20l)  )
        if(False):
            print('__ .dE_eq_EoldGas() __') 
            wsnm1,wsnm2 = 'srim132Xe_Air','srim40Ar_Air'
            Pa0,dgC0 = 101325., 20.
            Pa1,dgC1 = Pa0*0.9, dgC0
            Pa2,dgC2 = Pa0*1.1, dgC0
            print('Pa1,Pa2=',Pa1,Pa2)
            E10,Tmm1 =  100., 10.     # OK 
            E20h = srWB.dEu_eq_EoldGas(wsnm1,wsnm2,E10,Tmm1,True,
                                       Pa1,dgC1,Pa2,dgC2)
            E20l = srWB.dEu_eq_EoldGas(wsnm1,wsnm2,E10,Tmm1,False, 
                                       Pa1,dgC1,Pa2,dgC2)
            print(' dEu_eq_EoldGas( {},{}, E10[{:.2f}],Tmm1[{:.2f}],Hside=T ) = {:.3f}'.format(
                wsnm1,wsnm2,E10,Tmm1,E20h)  )
            print(' dEu_eq_EoldGas( {},{}, E10[{:.2f}],Tmm1[{:.2f}],Hside=F ) = {:.3f}'.format(
                wsnm1,wsnm2,E10,Tmm1,E20l)  )
            E20h = srWB.dEt_eq_EoldGas(wsnm1,wsnm2,E10,Tmm1,True,
                                       Pa1,dgC1,Pa2,dgC2)
            E20l = srWB.dEt_eq_EoldGas(wsnm1,wsnm2,E10,Tmm1,False, 
                                       Pa1,dgC1,Pa2,dgC2)
            print(' dEt_eq_EoldGas( {},{}, E10[{:.2f}],Tmm1[{:.2f}],Hside=T ) = {:.3f}'.format(
                wsnm1,wsnm2,E10,Tmm1,E20h)  )
            print(' dEt_eq_EoldGas( {},{}, E10[{:.2f}],Tmm1[{:.2f}],Hside=F ) = {:.3f}'.format(
                wsnm1,wsnm2,E10,Tmm1,E20l)  )
         
    print('@@main: -- Fin ---')
