# -*- coding: utf-8 -*-
"""
    Module: pySRIMfit
    File:   t_srimWBcnv_csv2xl.py
    Descr.: TEST srimWBcnv_csv2xl()
    Update: 220523 build start Ay
            220523 v.1.0 done 
    Last:   230310 v.1.1 refactored

@author: Ayoshida(RIKEN,Nishina center)
"""

""" import: standard lib.       
----.---.---.---.---.---.---.---.---.---.---.---.---"""
import  xlwings     as  xw
import  sys
import  os
import  glob

""" import: my custom lib.       
----.---.---.---.---.---.---.---.---.---.---.---.---"""
#import  aypylib             as ay 

""" import: from this package   
----.---.---.---.---.---.---.---.---.---.---.---.---"""
from    pySRIMfit   import  (srimWScnv,srimWBcnv_csv2xl)

""" ========================================================
            Main
    ========================================================"""
if __name__ == '__main__':
    import  time

    """ Test-CTRL Sw ---.---.---.---.---.---.---.---.---"""
    SwTest01 = False    # unit test
    SwTest02 = True     # helper func test

    """ run params """
    #__ Input: SRIM output (text file) 
    fnIn  = './add_SRIMoutCSV_eg/SRIMout_084Kr.xlsx'
    #__ Output: converted result; Excel SRIMwb
    fnOut = './MySRIMwb_out.xlsx'
    #__ Input_prototype: for Excel SRIMwb
    fnPty  = '../_proto/_MySRIMwb_prtyp.xlsx'
    snPty  = '_prtyp_'              # fnPty: prototype sheet name

    """ test01 : unit test
        input  = fnIn   SRIMout.xlsx        CSV book
        output = fnOut  MySRIMwb_out.xlsx   converted Excel file
        --------
        Elapsed = 55 sec / one CSV sheet
    ----.---.---.---.---.---.---.---.---.---.---.---.---"""
    if(SwTest01):
        """ file prep. """ 
        if(not os.path.exists(fnIn)):   # check fnIn
            print('err:main: {0} not found'.format(fnIn))
            sys.exit()
    
        xlapp = xw.App(visible=False)   # set xlwings be silent
        xlapp.display_alarts = False
        xwb = xw.Book(fnPty)            # open prototype WB
        xwb.save(fnOut)                 # save it as Output file name
        xwb.close()
        xwb = xw.Book(fnOut)            # re-open it
        swsc = srimWScnv()              # make srimWScnv instance
        
        xwbcsv = xw.Book(fnIn)
        for i,xwscsv in enumerate(xwbcsv.sheets):
            print(i,')',xwscsv.name)            
            xws= xwb.sheets[snPty].copy(name='new') # copy prtyp sheet to the end
            tms = time.time()
            swsc.srCSV2xlWS(xwscsv,xws)             # convert to Excel WS
            tme = time.time()
            print("elapsed[s]={:.2f}".format(tme-tms))

        xwbcsv.close()
        xwb.sheets[snPty].delete()      # remove prtyp sheet
        xwb.save(fnOut)                 # save converted result
        xlapp.quit()
        xlapp.kill()
        print('@@main: save',fnOut)

    """ test02 : helper func test
    ----.---.---.---.---.---.---.---.---.---.---.---.---"""
    if(SwTest02):
        csvfnDir = './add_SRIMoutCSV_eg/'
        csvfnL = glob.glob(csvfnDir+'*.xlsx')
        print('outfnL=',csvfnL)
        tms = time.time()
        srimWBcnv_csv2xl(csvfnL=csvfnL)
        tme = time.time()
        print("elapsed[s]={:.2f}".format(tme-tms))
        print('@@main: save',fnOut)

    print('@@main: -- Fin ---')
