# -*- coding: utf-8 -*-
"""
    Module: pySRIMfit
    File:   t_srimWBcnv_pick2xl.py
    Descr.: TEST srimWBcnv_pick2xl(),_srWB2xl()
    Update: 220515 build start Ay
            220522 v.1.0 done 
    Last:   230310 v.1.1 refactored

@author: Ayoshida(RIKEN,Nishina center)
"""

""" import: standard lib.       
----.---.---.---.---.---.---.---.---.---.---.---.---"""
import  xlwings     as  xw
import  sys
import  os

""" import: my custom lib.       
----.---.---.---.---.---.---.---.---.---.---.---.---"""
#import  aypylib             as ay 

""" import: from this package   
----.---.---.---.---.---.---.---.---.---.---.---.---"""
from    pySRIMfit   import  (srimWB,srimWScnv,
                             srimWBcnv_srWB2xl,srimWBcnv_pick2xl)

""" ========================================================
            Main
    ========================================================"""
if __name__ == '__main__':
    import  time

    """ Test-CTRL Sw ---.---.---.---.---.---.---.---.---"""
    SwTest01 =  False   # unit test
    SwTest02 =  True    # helper func test: srimWBcnv_pick2xl()
    SwTest03 =  False   # helper func test: srimWBcnv_srWB2xl()

    """ run params """
    #__ Input: pySRIM WB ; MySRIMwb.pickle file path
    dirIn  = './'
    #__ Output: converted result; Excel SRIMwb
    fnOut = './MySRIMwb_out.xlsx'
    #__ Input_prototype: for Excel SRIMwb
    fnPty  = '../_proto/_MySRIMwb_prtyp.xlsx'
    snPty  = '_prtyp_'              # fnPty: prototype sheet name

    """ test01 : unit test
        input    = dirOut    MySRIMwb.pickle    pickle file
        output   = fnOut     MySRIMwb_out.xlsx  converted Excel file
        ---------
        Elapsed = 1.5 sec / one srimWS()
     ----.---.---.---.---.---.---.---.---.---.---.---.---"""
    if(SwTest01):
        """ file prep. """ 
        swb = srimWB()                  # make a srimWB instance
        if(not swb.loadWS(path=dirIn)): # load SRIMwb.pickle
            print('err:main: {} not found'.format(dirIn))
            sys.exit()
        if(not os.path.exists(fnPty)):  # check fnPty
            print('err:main: {} not found'.format(fnPty))
            sys.exit()
            
        xlapp = xw.App(visible=False)   # set xlwings be silent
        xlapp.display_alarts = False
        xwb = xw.Book(fnPty)            # open prototype WB
        xwb.save(fnOut)                 # save it as Output file name
        xwb.close()
        xwb = xw.Book(fnOut)            # re-open it
        swsc = srimWScnv()              # make srimWScnv instance
    
        for i,sws in enumerate(swb.WSL):
            print(i,')',sws)
            snm = sws.wsName
            xws= xwb.sheets[snPty].copy(name=snm)   # copy prtyp sheet to the end
            tms = time.time()
            swsc.srWS2xlWS(sws,xws)                 # convert sws to Excel WS
            tme = time.time()
            print("elapsed[s]={:.2f}".format(tme-tms))
    
        xwb.sheets[snPty].delete()      # remove prtyp sheet
        xwb.save(fnOut)                 # save converted result
        xlapp.quit()
        xlapp.kill()
        print('@@main: save',fnOut)

    """ test02 : using helper func: srimWBcnv_pick2xl()
        ---------
        Elapsed = 137 sec / full MySRIMwb.xlsx ; incl. 315 sheets
    ----.---.---.---.---.---.---.---.---.---.---.---.---"""
    if(SwTest02):
        tms = time.time()
        srimWBcnv_pick2xl(dirIn=dirIn, xlfnOut=fnOut)
        tme = time.time()
        print("elapsed[s]={:.2f}".format(tme-tms))
        print('@@main: save',fnOut)

    """ test03 : using helper func: srimWBcnv_srWB2xl()
    ----.---.---.---.---.---.---.---.---.---.---.---.---"""
    if(SwTest03):
        tms = time.time()
        srWB = srimWB()
        if(not srWB.loadWS(path=dirIn)): # load SRIMwb.pickle
            print('err:main: {} not found'.format(dirIn))
            sys.exit()
        srimWBcnv_srWB2xl(srWB, xlfnOut=fnOut)
        tme = time.time()
        print("elapsed[s]={:.2f}".format(tme-tms))
        print('@@main: save',fnOut)

    print('@@main: -- Fin ---')

