# -*- coding: utf-8 -*-
"""
    Module: pySRIMfit
    File:   t_srimWBcnv_xl2pick.py
    Descr.: TEST srimWBcnv_xl2pick(), _xl2srWB()
    Update: 220403 build start Ay
            220522 v.1.0 done 
    Last:   230408 v.1.1 refactored
    
@author: Ayoshida(RIKEN,Nishina center)
"""

""" import: standard lib.       
----.---.---.---.---.---.---.---.---.---.---.---.---"""
import  xlwings     as  xw
import  sys
import  os

""" import: my custom lib.       
----.---.---.---.---.---.---.---.---.---.---.---.---"""
#import  aypylib             as ay 

""" import: from this package   
----.---.---.---.---.---.---.---.---.---.---.---.---"""
from    pySRIMfit   import  (srimWB,srimWScnv,
                             srimWBcnv_xl2pick,srimWBcnv_xl2srWB)

""" ========================================================
            Main
    ========================================================"""
if __name__ == '__main__':
    import  time
    
    """ Test-CTRL Sw ---.---.---.---.---.---.---.---.---"""
    SwTest01 =  False   # unit test
    SwTest02 =  True    # helper func test: srimWBcnv_xl2pick()
    SwTest03 =  False   # helper func test: srimWBcnv_xl2srWB()
    SwTest04 =  False   # conv. full MySRIMwb.xlsx

    """ run params """
    #__ Input: Excel SRIMwb
    #fnIn  = './_MySRIMwb_eg/_samples/MySRIMwb_test1.xlsx'  # for test
    #fnIn  = './_MySRIMwb_eg/_samples/MySRIMwb_minE5.xlsx'
    fnIn  = './_MySRIMwb_eg/_samples/MySRIMwb_full_220909.xlsx'
    #__ Output: converted result; pySRIM WB
    dirOut = './'                           # defa. ./MySRIMwb.pickle

    """ test01 : unit test
        input   = fnIn      MySRIMwb.xlsx   short test file
        output  = dirOut    MySRIMwb.pickle converted pickle file
        ---------
        Elapsed = 0.2 sec / one sheet in MySRIMwb.xlsx
    ----.---.---.---.---.---.---.---.---.---.---.---.---"""
    if(SwTest01):
        """ file prep. """ 
        if(not os.path.exists(fnIn)):   # check fnIn
            print('err:main: {} not found'.format(fnIn))
            sys.exit()
       
        #xwsID = 'srim'      # Excel WS name must start from this ID
        xlapp = xw.App(visible=False)       # set xlwings be silent
        xlapp.display_alarts = False
        xwb = xw.Book(fnIn)                 # open MySRIMwb
        swb = srimWB()                      # make a srimWB instance
        
        for i,xws in enumerate(xwb.sheets):
            print(i,')',xws.name)
            if(swb.xlWSid not in xws.name): continue
            swsc = srimWScnv()              # make a srimWScnv instance
            tms = time.time()
            sws  = swsc.xlWS2srWS(xws)      # convert xws to srimWS
            tme = time.time()
            print("elapsed[s]={:.2f}".format(tme-tms))
            #sws.info()
            swb._appendWS( sws )              # append srimWS to srimWB   
        swb.saveWS(path=dirOut)         # save as pickle
        xwb.close()
        xlapp.quit()
        xlapp.kill()
        # reload SRIMwb from the pickle
        #swb2 = pysr.srimWB()
        #swb2.loadWS()
        print('@@main: save MySRIMwb.pickle')

    """ test02 : using helper func : srimWBcnv_xl2pick()
        ---------
        Elapsed = 1.2 sec / 2-sheets in fnIn.xlsx
    ----.---.---.---.---.---.---.---.---.---.---.---.---"""
    if(SwTest02):
        tms = time.time()
        srWB= srimWBcnv_xl2pick(xlfnL=[fnIn],dirOut=dirOut)
        tme = time.time()
        print("elapsed[s]={:.2f}".format(tme-tms))
        print('@@main: save MySRIMwb.pickle')

    """ test03 : using helper func : srimWBcnv_xl2srWB()
        ---------
        Elapsed = 1.1 sec / 2-sheets in fnIn.xlsx
    ----.---.---.---.---.---.---.---.---.---.---.---.---"""
    if(SwTest03):
        tms = time.time()
        srWB= srimWBcnv_xl2srWB(xlfnL=[fnIn])
        tme = time.time()
        print("srCSV2xlWS(): elapsed[s]={:.2f}".format(tme-tms))

    """ test04 : conv. full MySRIMwb.xlsx
        ---------
        Elapsed = 137 sec / full MySRIMwb.xlsx ; incl. 315 sheets
    ----.---.---.---.---.---.---.---.---.---.---.---.---"""
    if(SwTest04):
        fnIn = './_MySRIMwb_eg/MySRIMwb_full_220909.xlsx'     # curr. full version
        tms = time.time()
        srWB=srimWBcnv_xl2pick(xlfnL=[fnIn],dirOut=dirOut)
        tme = time.time()
        print("elapsed[s]={:.2f}".format(tme-tms))
        print('@@main: save MySRIMwb.pickle')
    
    print('@@main: -- Fin ---')

