# -*- coding: utf-8 -*-
"""
    Module: pySRIMfit
    File:   mySRIM.py
    Descr.: def. class mySRIM ; common srimWB()
    Update: 230319 v.1.1 build Ay
    Last:   230424 v.1.1 refactored
    
@author: Ayoshida(RIKEN,Nishina center)
"""

""" import: standard lib.       
----.---.---.---.---.---.---.---.---.---.---.---.---"""

""" import: my custom lib.       
----.---.---.---.---.---.---.---.---.---.---.---.---"""
#import  aypylib             as ay 

""" import: from this package   
----.---.---.---.---.---.---.---.---.---.---.---.---"""
from    pySRIMfit   import  (srimWB, e5SRIM)

""" .===.===.===.===.===.===.===.===.===.===.===.===.===.===.===.===
        class mySRIM
====.===.===.===.===.===.===.===.===.===.===.===.===.===.===.=== === """
srWB_common = None

class mySRIM( srimWB , e5SRIM ):
    """ Common use srimWB() to eliminate multi-load(MySRIMwb)

Params. for constructor:
    non
Attributes:
  see help(srimWB)
    ----.---.---.---.---.---.---.---.---.---.---.---.---"""

    """ class Attributes
    ----.---.---.---.---.---.---.---.---.---.---.---.---"""    
    def _myclear(self):
        self.WBpath     = srWB_common.WBpath
        self.WBname     = srWB_common.WBname
        self.WSL        = srWB_common.WSL
        self.nWS        = srWB_common.nWS
        self.WSnameL    = srWB_common.WSnameL
        self.WSnameLDB  = srWB_common.WSnameLDB
        self.curWS      = None
        self.curWSname  = ''
    
    def __init__(self):
        """  Constructor
        ----.---.---.---.---.---.---.---.---.---.---.---.---"""
        global srWB_common
        if(srWB_common is None):
            srWB_common = srimWB()
            srWB_common.loadWS()
        self._myclear()


""" ========================================================
            Test Main
    ========================================================"""
if __name__ == '__main__':
    def _help(sr1,sr2):
        global srWB_common
        print('___ class mySRIM() mechanism ___')
        print('* Its instances are different.')
        print('  id(sr1),id(sr2) = ',id(sr1),id(sr2))
        print('* But, those attributes are same at the beginning.')
        print('  id(sr1.WSL),id(sr2.WSL) = ',id(sr1.WSL),id(sr2.WSL))
        print('* Those attributes can change after that.')
        print('  sr1.curWS=',sr1.curWS)
        print('  sr2.curWS=',sr2.curWS)
        print('* The common srimWB() ; id(srWB_common) = {} : hidden'.format(
                id(srWB_common)))
        print('  is initialized at the first mySRIM() call,' \
              'and is kept constant.')
        
    sr1,wsn1 = mySRIM(),'srim40Ar_Si'
    sr2,wsn2 = mySRIM(),'srim84Kr_Si'
    
    print('sr1.maxLETt({}) = '.format(wsn1),sr1.maxLETt(wsn1))
    print('sr2.maxLETt({}) = '.format(wsn2),sr2.maxLETt(wsn2))
    _help(sr1,sr2)

    print('ver=',sr1.VerInfo)
    sr1.e5_dEssd()


    print('@@main: -- Fin ---')


""" ========================================================
        ref) Numbered ref
    ========================================================
    
------------------------------------------------------------------
"""