# -*- coding: utf-8 -*-
"""
    Module: pySRIMfit
    File:   srimWBupd.py
    Descr.: Update MySRIMwb.xlsx & .pickle
    Update: 230311 build start Ay
    Last:   230422 v.1.1 done
    
@author: Ayoshida(RIKEN,Nishina center)
"""

""" import: standard lib.       
----.---.---.---.---.---.---.---.---.---.---.---.---"""
import  xlwings     as  xw
import  os
import  shutil 
import  glob

""" import: my custom lib.       
----.---.---.---.---.---.---.---.---.---.---.---.---"""
#import  aypylib             as ay 

""" import: from this package   
----.---.---.---.---.---.---.---.---.---.---.---.---"""
from    pySRIMfit   import  (srimWB,
                             srimWBcnv_xl2srWB,
                             srimWBcnv_srWB2xl, 
                             srimWBcnv_out2xl,  srimWBcnv_csv2xl)

""" .===.===.===.===.===.===.===.===.===.===.===.===.===.===.===.===
            Helper func for Main
====.===.===.===.===.===.===.===.===.===.===.===.===.===.===.=== === """

def get_menuNo( mnL:list )->int :
    for mn in mnL:
        print(mn)
    val = input('No= ')
    try:
        mnNo = int(val)
    except ValueError:
        mnNo = 9
    return(mnNo)

_menu_Main=[   
    ' ',
    '==== MySRIMwb Updater ====',
    ' 0) Show    Dir & File',
    ' 1) Show    Contents',
    ' 2) Remove  Sheet',
    ' 3) Convert SRIM-2013 data',
    ' 4) Append  Sheet',
    ' 5) Save    Book',
    ' 8) How To  Note',
    ' 9) exit'  ]
_menu_Show=[
    '---- Show Contents of MySRIMwb ----',
    ' 1) ~tmp.pickle',
    ' 2) ~tmp.xlsx',
    ' 3) diff ~tmp.pickle and ~tmp.xlsx',
    ' 4) ~add.xlsx',
    ' 5) ~new.pickle',
    ' 6) ~new.xlsx',
    ' 9) exit' ]
_menu_Remv=[
    '---- Remove WkSheets from ~tmp.pickle ----',
    ' 1) remove Beam_Target',
    ' 2) remove Beam',
    ' 3) remove Target',
    ' 9) exit' ]
_menu_Conv=[
    '---- Convert SRIM-2013 Output data to ~add.xlsx  ----',
    ' 1) Conv. SRIM TEXT to ~add.xlsx',
    ' 2) Conv. SRIM CSV  to ~add.xlsx',
    ' 9) exit' ]
_menu_Apnd=[
    '---- Append ~add.xlsx to ~tmp.pickle ----',
    ' 1) Check  sheet name list',
    ' 2) Append ~add.xlsx to ~tmp.pickle',
    ' 9) exit' ]
_menu_Save=[
    '---- Save ~tmp ----',
    ' 1) Save ~tmp.pickle as ~new.pickle & ~new.xlsx',
    ' 2) Save ~tmp.xlsx   as ~new.pickle & ~new.xlsx',
    ' 9) exit' ]
_menu_HowTo=[
    '---- How To Note ----',
    ' 1) in Japanese',
    ' 2) in English',
    ' 9) exit' ]
_menu_NoteJ=[
    '---- How To Note ----',
    '◎ 今まで使っていた MySRIMwb.xlsx を変換するには、',
    '  1: 元：MySRIMwb.xlsx を、予め ~\pySRIMfit\_MySRIMwb にコピーしておく',
    '     同時に ~\pySRIMfit\_MySRIMwb\MySRIMwb.pickle を削除しておく'
    '  2: このプログラムを一旦終了し、再実行する',
    '  3: Menu= 5) Save Book',
    '  4:       2) Save ~tmp.xlsx   as ~new.pickle & ~new.xlsx',
    '  5: Menu= 9) exit  で終了してから、',
    '  6: 変換出力されたファイルの名前変更： .pickleファイルのみでOKです',
    '    MySRIMwb_new.pickle --> MySRIMwb.pickle',
    '  7: 名前変更した .pickle ファイルを、~\pySRIMfit\_MySRIMwb に保存',
    '  以上で、元：MySRIMwb.xlsx と MySRIMwb.pickle が同期されます。',
    '◎ class srimWS を変更したら、.pickle も作り直す必要があります',
    '   よって、.pickle に変換する前の元ファイル；',
    '    .xlsx や SRIM-TEXT, SRIM-CSV ファイル等は、',
    '   別途保存しておいてください。',
    ' 9) exit' ]
_menu_NoteE=[
    '---- How To Note ----',
    '# How to convert your MySRIMwb.xlsx used in Excel-SRIMfit',
    '  1: copy your MySRIMwb.xlsx to ~\pySRIMfit\_MySRIMwb; over write',
    '     and delete ~\pySRIMfit\_MySRIMwb\MySRIMwb.pickle'
    '  2: restart this script, again.',
    '  3: Menu= 5) Save Book',
    '  4:       2) Save ~tmp.xlsx   as ~new.pickle & ~new.xlsx',
    '  5: Menu= 9) exit',
    '  6: rename MySRIMwb_new.pickle --> MySRIMwb.pickle',
    '  7: copy the MySRIMwb.pickle to ~\pySRIMfit\_MySRIMwb',
    "  That's all.",
    ' 9) exit' ]

""" SRIM DB : File constats
----.---.---.---.---.---.---.---.---.---.---.---.---"""
#   Current DB dir
DirCur      = os.path.join(os.path.dirname(__file__),'./_MySRIMwb/')
#   Prototype dir
DirProto    = os.path.join(os.path.dirname(__file__),'./_proto/')
#   Add-Data ; SRIM-2013 output.txt 
DirAddCSV   = os.path.join(os.path.dirname(__file__),'./add_SRIMoutCSV/')
#   Add-Data ; SRIM-2013 output.txt -> read as CSV -> save as *.xlsx 
DirAddTXT   = os.path.join(os.path.dirname(__file__),'./add_SRIMoutTXT/')
#   Tempolary Work dir == home dir where run .py
DirTmp      = './'
# File names
FnmCurXL    = 'MySRIMwb.xlsx'
FnmCurPK    = 'MySRIMwb.pickle'
FnmPrtXL    = '_MySRIMwb_new.xlsx'
FnmPrtPK    = '_MySRIMwb_new.pickle'
FnmTmpXL    = 'MySRIMwb_tmp.xlsx'
FnmTmpPK    = 'MySRIMwb_tmp.pickle'
FnmAddXL    = 'MySRIMwb_add.xlsx'
FnmNewXL    = 'MySRIMwb_new.xlsx'
FnmNewPK    = 'MySRIMwb_new.pickle'

""" gloval Work area
----.---.---.---.---.---.---.---.---.---.---.---.---"""
srWBTmp,srXWTmp     = None, None
xlapp = None

""" local funcs. for srimWBupdater()
----.---.---.---.---.---.---.---.---.---.---.---.---"""
def main_init():
    global srWBTmp,srXWTmp,xlapp
    """ copy Current -> ~tmp """
    print('Preparation before Up Date')
    print(' copying Current:{} -> Temp.Work:(~tmp) '.format(DirCur))

    """ copy & read: ~tmp.xlsx """
    fnFr1,fnTo1 = DirCur+FnmCurXL,DirTmp+FnmTmpXL
    if(not os.path.exists(fnFr1)):
        print('#@ {} not found. Use a clean prototype.'.format(fnFr1))
        fnFr1 = DirProto+FnmPrtXL
    shutil.copy(fnFr1,fnTo1)
    print(' reading : ',fnTo1)
    xlapp = xw.App(visible=False)   # set xlwings be silent
    xlapp.display_alarts = False
    srXWTmp = xw.Book(fnTo1)
    """ copy & read ~tmp.pickle """
    fnFr2,fnTo2 = DirCur+FnmCurPK,DirTmp+FnmTmpPK
    if(not os.path.exists(fnFr2)):
        print('#@ {} not found. Use a clean prototype.'.format(fnFr2))
        fnFr2 = DirProto+FnmPrtPK
    shutil.copy(fnFr2,fnTo2)
    print(' reading : ',fnTo2)
    srWBTmp = srWB_open( DirTmp, fnTo2 )
    #show_dir()

def main_term():
    global srXWTmp,xlapp
    #srXWTmp.close()
    xlapp.quit()
    xlapp.kill()

def chk_fexist( fnm:str, swMsg:bool=True ):
    if(not os.path.exists(fnm)):
        if(swMsg):
            print('Err: {} NOT found'.format(fnm))
        return( False)
    return( True )

def srWB_open( path:str, fnm:str ):
    srWB = srimWB()
    srWB.loadWS(path=path,fnm=fnm)
    return( srWB )
    
def show_dir():
    def glob_files( path:str ):
        fnL = glob.glob(path)
        for fn in fnL:
            print('  ',os.path.basename(fn))
        
    print()
    print('---- Show Dir & Files ----')
    print('{} : ~cur: Current SRIMfit DB folder'.format(DirCur))
    glob_files(DirCur+'*.pickle')
    glob_files(DirCur+'*.xlsx')
    print('{} : ~addTXT: SRIM-2013 output(*.txt)  to add'.format(DirAddTXT))
    glob_files(DirAddTXT+'*.txt')
    print('{} : ~addCSV: SRIM-2013 output(*.xlsx) to add'.format(DirAddCSV))
    glob_files(DirAddCSV+'*.xlsx')
    print('./ HOME dir : ~tmp, ~new: Tempolary work area')
    glob_files(DirTmp+'*.pickle')
    glob_files(DirTmp+'*.xlsx')

def show_xlsx_info( srXW, show:bool=True ) -> object:
    shnmL = [ v.name for v in srXW.sheets]
    if('VerLog' in shnmL):
        shnmL.remove('VerLog')
    """ wsname だけ copy した srWB を生成 """
    srWB= srimWB()
    srWB.WSnameL = shnmL
    srWB.nWS = len(shnmL)
    if(show): 
        srWB.info()
    return( srWB )

def show_xlsx_name( fnXlsx:str ) -> list:
    _srXW = xw.Book(fnXlsx)
    shnmL = [ sh.name for sh in _srXW.sheets]
    for shnm in shnmL:
        print('  ',shnm)
    _srXW.close()
    return( shnmL )
     
def show_diff( srWB, srXW ):
    srWBXW = show_xlsx_info( srXW, show=False )
    s_WB = set(srWB.WSnameL)
    s_XW = set(srWBXW.WSnameL)
    if(s_WB == s_XW):
        print(' WkSheets name of both ')
        print('  "{}" and "{}"'.format(srWB.WBname,srXW.name))
        print(' are IDENTICAL.')
        return
    s1 = s_WB - s_XW
    s2 = s_XW - s_WB
    s3 = s1 | s2
    print('difference between:')
    print(srWB.WBname,' vs. ',srXW.name)
    for wsnm in s3:
        if(wsnm in s1): 
            print('     <- ',wsnm,'   ')
        if(wsnm in s2): 
            print('        ',wsnm,' ->')

def show_SRIMwb( mnNo:int ):
    global srWBTmp,srXWTmp
    
    if(  mnNo ==  1):
        srWBTmp.info()
    elif(mnNo ==  2):
        show_xlsx_info( srXWTmp, show=True )
    elif(mnNo ==  3):
        show_diff( srWBTmp, srXWTmp )
    elif(mnNo ==  4):
        fn = DirTmp+FnmAddXL
        if(not chk_fexist(fn)):  return
        show_xlsx_name( fn )
    elif(mnNo ==  5):
        if(not chk_fexist(DirTmp+FnmNewPK)):    return
        _srWB = srWB_open( DirTmp, FnmNewPK )
        _srWB.info()
    elif(mnNo ==  6):
        fn = DirTmp+FnmNewXL
        if(not chk_fexist(fn)):  return
        show_xlsx_name( fn )        
        
def remv_WS( mnNo:int ):
    global srWBTmp
    
    def inp_Bm():
        print(' Which Beam   ? : like "Kr" or "86Kr"' )
        Bm = input('  Beam  = ')
        return( Bm )
    def inp_Tg():
        print(' Which Target ? : like "Si" or "Silicon"' )
        Tg = input('  Target= ')
        return( Tg )

    Bm,Tg = None, None        
    if(  mnNo ==  1):
        Bm = inp_Bm()
        Tg = inp_Tg()
    elif(mnNo ==  2):
        Bm = inp_Bm()   
    elif(mnNo ==  3):
        Tg = inp_Tg()
    else:   return
    
    wsnmL = srWBTmp.getWSnmL(Beam=Bm, Trg=Tg)
    if(len(wsnmL) < 1):
        print('Err:Can NOT find WkSheet name. Do nothing.')
        return
    print(' Following WkSheets are removed from ~tmp.pickle')
    for i,wsnm in enumerate(wsnmL):
        print('  {}) {}'.format(i,wsnm))
    yn= input(' Remove them OK ? (y/n)= ')
    if(yn == 'y'):
        for i,wsnm in enumerate(wsnmL):
            st = srWBTmp._removeWSnm(wsnm)
            if(st == True):
                print('  {}) {} removed.'.format(i,wsnm))
            else:
                print('  {}) {} remove FAILED.'.format(i,wsnm))

def conv_WS( mnNo:int ):
    global srWBTmp,srXWAdd

    def _check( _fnInL:list, _fnWC:str, _fnOut:str ) -> bool:
        if(len(_fnInL) < 1):
            print('Err:{} found NOTHING.'.format(_fnInL))
            return( False )
        print(' Following files are converted to ~add.xlsx')
        for i,wsnm in enumerate(_fnInL):
            print('  {}) {}'.format(i,wsnm))
        yn= input(' Convert them OK ? (y/n)= ')
        if(yn != 'y'):
            return( False )
        if(chk_fexist(_fnOut)):
            print(' Output file: {} exist,already.'.format(_fnOut))
            yn= input(' Over-write OK ? (y/n)= ')
            if(yn != 'y'):
                return( False )
        return( True )
    
    fnOut = DirTmp+FnmAddXL
    if(  mnNo ==  1):
        fnWC  = DirAddTXT+'*.txt'
        fnInL = glob.glob(fnWC)
        if(not _check(fnInL,fnWC,fnOut)): return
        print(' Start conversion')
        srimWBcnv_out2xl(outfnL=fnInL,xlfnOut=fnOut)
    elif(mnNo ==  2):
        fnWC  = DirAddCSV+'*.xlsx'
        fnInL = glob.glob(fnWC)
        if(not _check(fnInL,fnWC,fnOut)): return
        print(' Start conversion')
        srimWBcnv_csv2xl(csvfnL=fnInL,xlfnOut=fnOut)
    else: return
    
    print(' Complete. Show ~add.xlsx')
    """ ~add.xlsx はまだ srimBm_Tg になっていないので info は不可 """
    show_xlsx_name( fnOut )
    print(' Please EDIT {} using MS-Excel'.format(fnOut))
    print(' * edit WkSheet names as srimBeam_Target')
    print(' * edit Target name, Gas, Corded ..')
    print(' * see Manual for detail')

def apnd_WS( mnNo:int ):
    global srWBTmp
    
    fnIn = DirTmp+FnmAddXL
    if(  mnNo == 1):
        print(' ~add.xlsx   : sheet names')
        nmLadd = show_xlsx_name( fnIn )
        #print(' ~tmp.pickle : sheet names')
        #print(srWBTmp.WSnameL)
        nmLtmp = srWBTmp.WSnameL
        nmLdup = []
        for wsnm in nmLadd:
            if(wsnm in nmLtmp):
                print('  [{}] exist in ~tmp.pickle'.format(wsnm))
                ws = srWBTmp.getWS(wsnm)
                print('    as ',ws)
                nmLdup.append(wsnm)
        if(len(nmLdup) > 0):
            yn = input('  Remove duplicated sheets above ? (y/n)= ')
            if(yn == 'y'):
                for wsnm in nmLdup:
                    srWBTmp._removeWSnm(wsnm)
            else:
                print('  Need to remove those duplications, before Append')
    elif(mnNo == 2):
        srWBadd = srimWBcnv_xl2srWB(xlfnL=[fnIn])
        for i,ws in enumerate(srWBadd.WSL):
            srWBTmp._appendWS(ws)
            print('  {}) {} appended'.format(i,ws.wsName))

def save_WB( mnNo:int ):
    global srWBTmp,srXWTmp

    def _chk( fnO ):
        if(chk_fexist(fnO,swMsg=False)):
            print(' Output file: {} exist,already.'.format(fnO))
            yn= input(' Over-write OK ? (y/n)= ')
            if(yn != 'y'):  return( False )
        return( True )
    
    def _swSort():
        yn = input('  Sort WSname ? (y/n)= ')
        if(yn != 'y'): return( 0 )        
        print('  Sort key options')
        print('   1 = sort by Beam_Z, Beam_A, Target_name')
        print('   2 = sort by Target_name, Beam_Z, Beam_A')
        no= input('  Sort key (1/2)= ')
        if(  no == '1'): return( 1 )
        elif(no == '2'): return( 2 )
        return( 0 )

    swSort = _swSort()
    if(  mnNo == 1):
        fnOut = DirTmp+FnmNewPK
        if(not _chk(fnOut)):   return
        if(swSort in [1,2]):
            srWBTmp._sortWSnmL(swSort=swSort)
        srWBTmp.saveWS(path=DirTmp,fnm=FnmNewPK)
        print(' {} saved.'.format(fnOut))
        fnOut = DirTmp+FnmNewXL
        if(not _chk(fnOut)):   return
        srimWBcnv_srWB2xl(srWBTmp, xlfnOut=fnOut)
        print(' {} saved.'.format(fnOut))
    elif(mnNo == 2):
        fnIn  = DirTmp+FnmTmpXL
        fnOut = DirTmp+FnmNewPK
        if(not _chk(fnOut)):   return
        #_srWB  = srimWBcnv_xl2pick(xlfnL=[fnIn], dirOut=DirTmp, 
        #                fnOut=FnmNewPK, swSave=True)
        _srWB  = srimWBcnv_xl2srWB(xlfnL=[fnIn])
        if(swSort in [1,2]):
            _srWB._sortWSnmL(swSort=swSort)
        _srWB.saveWS(path=DirTmp,fnm=FnmNewPK)
        print(' {} saved.'.format(fnOut))
        fnOut = DirTmp+FnmNewXL
        if(not _chk(fnOut)):   return
        # shutil.copy(fnIn,fnOut)
        srimWBcnv_srWB2xl(_srWB, xlfnOut=fnOut)
        print(' {} saved.'.format(fnOut))


""" .===.===.===.===.===.===.===.===.===.===.===.===.===.===.===.===
        Helper func : srimWBupdater() 
====.===.===.===.===.===.===.===.===.===.===.===.===.===.===.=== === """
def srimWBupdater():
    main_init()
    while(True):
        mnNo = get_menuNo(_menu_Main)
        if(  mnNo == 9): break
        elif(mnNo == 0):
            show_dir()
        elif(mnNo == 1):
            mnNo = get_menuNo(_menu_Show)
            show_SRIMwb( mnNo )
        elif(mnNo == 2):
            mnNo = get_menuNo(_menu_Remv)
            remv_WS( mnNo )
        elif(mnNo == 3):
            mnNo = get_menuNo(_menu_Conv)
            conv_WS( mnNo )
        elif(mnNo == 4):
            mnNo = get_menuNo(_menu_Apnd)
            apnd_WS( mnNo )
        elif(mnNo == 5):
            mnNo = get_menuNo(_menu_Save)
            save_WB( mnNo )
        elif(mnNo == 8):
            mnNo = get_menuNo(_menu_HowTo)
            if(  mnNo ==  1):
                 mnNo = get_menuNo(_menu_NoteJ)
            elif(mnNo ==  2):
                 mnNo = get_menuNo(_menu_NoteE)            
    main_term()
    

""" .===.===.===.===.===.===.===.===.===.===.===.===.===.===.===.===
            Main
    note) in Jpn
    もし途中終了した場合は、Xlwings が開いた タスクが残る場合があります。
    その場合は、タスクマネージャーから、Microsoft Excel を「タスク終了」してください。
====.===.===.===.===.===.===.===.===.===.===.===.===.===.===.=== === """
if __name__ == '__main__':

    srimWBupdater()

    print('@@main: -- Fin ---')

